## unicorn-engine 2.0.1

=== CMakeLists.txt ===
# CMake setup for Unicorn 2.
# By Huitao Chen & Nguyen Anh Quynh, 2019-2020

cmake_minimum_required(VERSION 3.1)

# Only required for MSVC, but we can't know the compiler at this point because we haven't
# called enable_language() or project(), and if we did that it would lock in the old
# policy. Setting these policies is harmless for non-MSVC though, so just enable them
# always.
if(CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
    # Set explicitly the policies we want rather than raising the base to the current
    # version. This prevents unintended behavior changes as CMake evolves and provides a
    # consistent experience across different CMake versions.
    # CMP0091: prevent msvcrt flags being added to default CMAKE_<LANG>_FLAGS_<CONFIG>
    cmake_policy(SET CMP0091 NEW)
    # CMP0092: prevent warning flags being added to default CMAKE_<LANG>_FLAGS for MSVC
    cmake_policy(SET CMP0092 NEW)
endif()

# Workaround to fix wrong compiler on macos.
if(APPLE AND NOT CMAKE_C_COMPILER)
    set(CMAKE_C_COMPILER "/usr/bin/cc")
endif()

# Detect if unicorn is compiled as the top-level project
set(PROJECT_IS_TOP_LEVEL OFF)
if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(PROJECT_IS_TOP_LEVEL ON)

    # Enable folder support
    set_property(GLOBAL PROPERTY USE_FOLDERS ON)
endif()

project(unicorn C)

# We depend on the availability of the CMAKE_MSVC_RUNTIME_LIBRARY, which is only
# available in CMake 3.15 and above (see also the comments above in regards to policy
# CMP0091).
if(MSVC AND CMAKE_VERSION VERSION_LESS "3.15")
    message(FATAL_ERROR "Please update CMake to 3.15 or greater.")
endif()

# mainline qemu mostly just uses compiler default
set(CMAKE_C_STANDARD 11)

set(UNICORN_VERSION_MAJOR 2)
set(UNICORN_VERSION_MINOR 0)
set(UNICORN_VERSION_PATCH 0)

include(bundle_static.cmake)

# Even though we generate shared lib and static archive at the same time, we still support
# using unicorn as a subdirectory so we have to respect BUILD_SHARED_LIBS.
#
# Also we would like users to link a native cmake target, instead of a custom target for better
# compatability.
option(BUILD_SHARED_LIBS "Build shared instead of static library" ${PROJECT_IS_TOP_LEVEL})
option(UNICORN_FUZZ "Enable fuzzing" OFF)
option(UNICORN_BUILD_TESTS "Build unicorn tests" ${PROJECT_IS_TOP_LEVEL})
option(UNICORN_INSTALL "Enable unicorn installation" ${PROJECT_IS_TOP_LEVEL})
set(UNICORN_ARCH "x86;arm;aarch64;riscv;mips;sparc;m68k;ppc;s390x;tricore" CACHE STRING "Enabled unicorn architectures")
option(UNICORN_TRACER "Trace unicorn execution" OFF)

foreach(ARCH_LOOP ${UNICORN_ARCH})
    string(TOUPPER "${ARCH_LOOP}" ARCH_LOOP)
    set(UNICORN_HAS_${ARCH_LOOP} TRUE)
endforeach()

if(MSVC)
    include_directories(
        ${CMAKE_CURRENT_SOURCE_DIR}/msvc
    )
else()
    include_directories(
        ${CMAKE_BINARY_DIR}
    )
endif()

include_directories(
    glib_compat
    qemu
    qemu/include
    include
    qemu/tcg
)

if(MSVC)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8)
        set(MSVC_FLAG  -D__x86_64__)
    elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
        set(MSVC_FLAG  -D__i386__)
    else()
        message(FATAL_ERROR "Neither WIN64 or WIN32!")
    endif()

    add_compile_options(
        -Dinline=__inline
        -D__func__=__FUNCTION__
        -D_CRT_SECURE_NO_WARNINGS
        -DWIN32_LEAN_AND_MEAN
        ${MSVC_FLAG}
        /I${CMAKE_CURRENT_SOURCE_DIR}/qemu/tcg/i386
    )

    # Disable some warnings
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4018>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4098>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4244>)
    add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4267>)

    # handle msvcrt setting being passed in CMAKE_C_FLAGS
    if(DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
        # do not support other methods of setting this (it would be more conformant, tho)
        message(FATAL_ERROR "please set msvcrt via CMAKE_C_FLAGS")
    endif()
    if(CMAKE_C_FLAGS MATCHES "[/-]MTd")
        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebug")
    elseif(CMAKE_C_FLAGS MATCHES "[/-]MDd")
        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebugDLL")
    elseif(CMAKE_C_FLAGS MATCHES "[/-]MT")
        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
    elseif(CMAKE_C_FLAGS MATCHES "[/-]MD")
        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
    endif()

    # prevent the arg from occurring more than once (not a big deal, just to keep tidy)
    string(REGEX REPLACE "[/-]M[TD]d?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
else()
    if(MINGW)
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpmachine
            OUTPUT_VARIABLE UC_COMPILER_VERSION)

        string(FIND "${UC_COMPILER_VERSION}" "i686" UC_RET)
        if(${UC_RET} GREATER_EQUAL "0")
            set(UNICORN_TARGET_ARCH "i386")
            set(UNICORN_CFLAGS -m32 -static-libgcc) # Workaround for github action bugs
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m32")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m32")
        else()
            set(UNICORN_TARGET_ARCH "i386")
            set(UNICORN_CFLAGS -m64 -mcx16)
            set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m64")
            set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
        endif()
    elseif(ANDROID_ABI)
        string(FIND "${ANDROID_ABI}" "arm64" UC_RET)
        file(WRITE ${CMAKE_BINARY_DIR}/adb.sh "#!/bin/bash\n\n# Auto-generated by CMakeLists.txt\n\nadb shell mkdir -p /data/local/tmp/build\n")

        if(${UC_RET} GREATER_EQUAL "0")
            set(UNICORN_TARGET_ARCH "aarch64")
        else()
            string(FIND "${ANDROID_ABI}" "armeabi" UC_RET)

            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "arm")
            else()
                set(UNICORN_TARGET_ARCH "i386")
            endif()
        endif()
    else()
        execute_process(COMMAND ${CMAKE_C_COMPILER} -dM -E -
            INPUT_FILE /dev/null
            OUTPUT_VARIABLE UC_COMPILER_MACRO)

        while(TRUE)
            string(FIND "${UC_COMPILER_MACRO}" "__x86_64__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "i386")
                string(FIND "${UC_COMPILER_MACRO}" "__ILP32__" UC_RET)
                if(${UC_RET} GREATER_EQUAL "0")
                    set(UNICORN_CFLAGS -mx32)
                    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mx32")
                    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -mx32")
                else()
                    set(UNICORN_CFLAGS -m64 -mcx16)
                    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -m64")
                    set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -m64")
                endif()
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__i386__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "i386")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__arm__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "arm")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__aarch64__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "aarch64")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__mips__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "mips")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__sparc__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "sparc")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__ia64__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "ia64")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "_ARCH_PPC" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "ppc")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__riscv" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "riscv")
                break()
            endif()
            string(FIND "${UC_COMPILER_MACRO}" "__s390__" UC_RET)
            if(${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "s390")
                break()
            endif()
            string(FIND ${UC_COMPILER_MACRO} "__tricore__" UC_RET)
            if (${UC_RET} GREATER_EQUAL "0")
                set(UNICORN_TARGET_ARCH "tricore")
                break()
            endif()
            message(FATAL_ERROR "Unknown host compiler: ${CMAKE_C_COMPILER}.")
        endwhile(TRUE)
    endif()

    set(EXTRA_CFLAGS "--extra-cflags=")
    if(UNICORN_HAS_X86)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_X86 ")
    endif()
    if(UNICORN_HAS_ARM)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_ARM ")
    endif()
    if(UNICORN_HAS_AARCH64)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_ARM64 ")
    endif()
    if(UNICORN_HAS_M68K)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_M68K ")
    endif()
    if(UNICORN_HAS_MIPS)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_MIPS -DUNICORN_HAS_MIPSEL -DUNICORN_HAS_MIPS64 -DUNICORN_HAS_MIPS64EL ")
    endif()
    if(UNICORN_HAS_SPARC)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_SPARC ")
    endif()
    if(UNICORN_HAS_PPC)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_PPC ")
    endif()
    if(UNICORN_HAS_RISCV)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_RISCV ")
    endif()
    if (UNICORN_HAS_S390X)
        set (EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_S390X ")
    endif()
    if (UNICORN_HAS_TRICORE)
        set (EXTRA_CFLAGS "${EXTRA_CFLAGS}-DUNICORN_HAS_TRICORE ")
    endif()

    set(EXTRA_CFLAGS "${EXTRA_CFLAGS}-fPIC")
    if(ANDROID_ABI)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS} --target=${CMAKE_C_COMPILER_TARGET}")
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS} --sysroot=${CMAKE_SYSROOT}")
    endif()
    if(UNICORN_FUZZ)
        set(EXTRA_CFLAGS "${EXTRA_CFLAGS} ${CMAKE_C_FLAGS}")
    endif()
    if(UNICORN_TRACER)
        set (EXTRA_CFLAGS "${EXTRA_CFLAGS} -DUNICORN_TRACER")
    endif()

    set(TARGET_LIST "--target-list=")
    if(UNICORN_HAS_X86)
        set(TARGET_LIST "${TARGET_LIST}x86_64-softmmu, ")
    endif()
    if(UNICORN_HAS_ARM)
        set(TARGET_LIST "${TARGET_LIST}arm-softmmu, ")
    endif()
    if(UNICORN_HAS_AARCH64)
        set(TARGET_LIST "${TARGET_LIST}aarch64-softmmu, ")
    endif()
    if(UNICORN_HAS_M68K)
        set(TARGET_LIST "${TARGET_LIST}m68k-softmmu, ")
    endif()
    if(UNICORN_HAS_MIPS)
        set(TARGET_LIST "${TARGET_LIST}mips-softmmu, mipsel-softmmu, mips64-softmmu, mips64el-softmmu, ")
    endif()
    if(UNICORN_HAS_SPARC)
        set(TARGET_LIST "${TARGET_LIST}sparc-softmmu, sparc64-softmmu, ")
    endif()
    if(UNICORN_HAS_PPC)
        set(TARGET_LIST "${TARGET_LIST}ppc-softmmu, ppc64-softmmu, ")
    endif()
    if(UNICORN_HAS_RISCV)
        set(TARGET_LIST "${TARGET_LIST}riscv32-softmmu, riscv64-softmmu, ")
    endif()
    if(UNICORN_HAS_S390X)
        set(TARGET_LIST "${TARGET_LIST}s390x-softmmu, ")
    endif()
    if (UNICORN_HAS_TRICORE)
        set (TARGET_LIST "${TARGET_LIST}tricore-softmmu, ")
    endif()
    set(TARGET_LIST "${TARGET_LIST} ")

    # GEN config-host.mak & target directories
    execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/qemu/configure
        --cc=${CMAKE_C_COMPILER}
        ${EXTRA_CFLAGS}
        ${TARGET_LIST}
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    )

=== debian/changelog ===
unicorn-engine (2.0.1-1) unstable; urgency=medium

  * New upstream version 2.0.1

 -- Timo Röhling <roehling@debian.org>  Fri, 04 Nov 2022 14:12:52 +0100

unicorn-engine (2.0.0-5) unstable; urgency=medium

  * Fix book keeping patch for RAM blocks
  * Apply Multi-Arch hint

 -- Timo Röhling <roehling@debian.org>  Thu, 29 Sep 2022 16:28:32 +0200

unicorn-engine (2.0.0-4) unstable; urgency=medium

  * Fix big endian issues (Closes: #1020536)

 -- Timo Röhling <roehling@debian.org>  Fri, 23 Sep 2022 16:40:19 +0200

unicorn-engine (2.0.0-3) unstable; urgency=medium

  * Try to fix book keeping for RAM blocks

 -- Timo Röhling <roehling@debian.org>  Thu, 22 Sep 2022 14:35:19 +0200

unicorn-engine (2.0.0-2) unstable; urgency=medium

  * Upload to unstable
  * Move Python to indep build
  * Fix setup.py and its antiquated distutils usage
  * No need to try and run non-existing tests for bindings
  * Work around test issues

 -- Timo Röhling <roehling@debian.org>  Wed, 21 Sep 2022 21:50:02 +0200

unicorn-engine (2.0.0-1) experimental; urgency=medium

  * New upstream version 2.0.0 (Closes: #1019449)
  * New SONAME libunicorn.so.2

 -- Timo Röhling <roehling@debian.org>  Sat, 10 Sep 2022 00:45:24 +0200

unicorn-engine (1.0.3-3) unstable; urgency=medium

  * Fix independent any/all builds

 -- Timo Röhling <roehling@debian.org>  Thu, 08 Sep 2022 09:43:30 +0200

unicorn-engine (1.0.3-2) unstable; urgency=medium

  * Fix d/copyright
  * Bump Standards-Version to 4.6.1
  * Override non-applicable lintian error
  * Use -fPIC instead of -fpic

 -- Timo Röhling <roehling@debian.org>  Thu, 08 Sep 2022 00:37:43 +0200

unicorn-engine (1.0.3-1) unstable; urgency=medium

  * Initial release. (Closes: #1003221)

 -- Timo Röhling <roehling@debian.org>  Mon, 11 Apr 2022 02:06:21 +0200

## unicorn-engine 2.0.1.post1

=== CMakeLists.txt ===
--- 
+++ 
@@ -45,7 +45,7 @@
 
 set(UNICORN_VERSION_MAJOR 2)
 set(UNICORN_VERSION_MINOR 0)
-set(UNICORN_VERSION_PATCH 0)
+set(UNICORN_VERSION_PATCH 1)
 
 include(bundle_static.cmake)

=== bindings/Makefile ===
# Unicorn Engine
# By Nguyen Anh Quynh & Dang Hoang Vu, 2015
DIFF = diff

SAMPLE_SOURCE = $(wildcard ../samples/*.c)
SAMPLE = $(SAMPLE_SOURCE:../samples/%.c=%)
SAMPLE := $(SAMPLE:mem_apis=)
SAMPLE := $(SAMPLE:sample_batch_reg=)
SAMPLE := $(SAMPLE:sample_x86_32_gdt_and_seg_regs=)
SAMPLE := $(SAMPLE:shellcode=)

UNAME_S := $(shell uname -s)
ifeq ($(UNAME_S), Linux)
ENV_VARS = LD_PRELOAD=librt.so LD_LIBRARY_PATH=../ DYLD_LIBRARY_PATH=../
else
ENV_VARS = LD_LIBRARY_PATH=../ DYLD_LIBRARY_PATH=../ LIBUNICORN_PATH=$(TRAVIS_BUILD_DIR)
endif


.PHONY: build install python c clean check test

build:
	$(MAKE) -C python gen_const
	$(MAKE) -C go gen_const
	$(MAKE) -C java gen_const
	$(MAKE) -C ruby gen_const
	python3 const_generator.py dotnet
	python3 const_generator.py pascal

install: build
	$(MAKE) -C python install
	$(MAKE) -C java install

test: $(SAMPLE:%=%.py.test)

c:
	$(MAKE) -C ../samples
python:
	$(MAKE) -C python
%.c.txt: c
	$(ENV_VARS) ../samples/$(@:%.c.txt=%) > $@
%.py.txt: python
	$(ENV_VARS) python3 python/$(@:%.txt=%) > $@

%.py.test: %.c.txt %.py.txt
	$(DIFF) -u $(@:%.py.test=%.c.txt) $(@:%.py.test=%.py.txt)

clean:
#	rm -rf *.txt
	$(MAKE) -C python clean
	$(MAKE) -C java clean

check:
	make -C python check

=== samples/Makefile ===
# Unicorn Engine
# By Nguyen Anh Quynh <aquynh@gmail.com>, 2015

include ../config.mk

UNAME_S := $(shell uname -s)

LIBDIR = ..
BIN_EXT =
AR_EXT = a

# Verbose output?
V ?= 0

CFLAGS += -Wall -Werror -I../include

LDFLAGS += -L$(LIBDIR) -lunicorn -lpthread -lm
ifeq ($(UNAME_S), Linux)
LDFLAGS += -lrt
endif

LDLIBS += -lpthread -lunicorn -lm

ifneq ($(CROSS),)
CC = $(CROSS)gcc
endif

ifeq ($(UNICORN_ASAN),yes)
CC = clang 
CXX = clang++
AR = llvm-ar
CFLAGS += -fsanitize=address -fno-omit-frame-pointer
LDFLAGS := -fsanitize=address ${LDFLAGS}
endif

# Cygwin?
ifneq ($(filter CYGWIN%,$(UNAME_S)),)
CFLAGS := $(CFLAGS:-fPIC=)
LDLIBS += -lssp
BIN_EXT = .exe
AR_EXT = a
# mingw?
else ifneq ($(filter MINGW%,$(UNAME_S)),)
CFLAGS := $(CFLAGS:-fPIC=)
BIN_EXT = .exe
AR_EXT = a
endif

ifeq ($(UNICORN_STATIC),yes)
ifneq ($(filter MINGW%,$(UNAME_S)),)
ARCHIVE = $(LIBDIR)/unicorn.$(AR_EXT)
else ifneq ($(filter CYGWIN%,$(UNAME_S)),)
ARCHIVE = $(LIBDIR)/libunicorn.$(AR_EXT)
else
ARCHIVE = $(LIBDIR)/libunicorn.$(AR_EXT)
endif
endif

.PHONY: all clean

UNICORN_ARCHS := $(shell if [ -e ../config.log ]; then cat ../config.log;\
				 else printf "$(UNICORN_ARCHS)"; fi)

SOURCES =
ifneq (,$(findstring arm,$(UNICORN_ARCHS)))
SOURCES += sample_arm.c
SOURCES += sample_armeb.c
endif
ifneq (,$(findstring aarch64,$(UNICORN_ARCHS)))
SOURCES += sample_arm64.c
SOURCES += sample_arm64eb.c
endif
ifneq (,$(findstring mips,$(UNICORN_ARCHS)))
SOURCES += sample_mips.c
endif
#ifneq (,$(findstring ppc,$(UNICORN_ARCHS)))
#SOURCES += sample_ppc.c
#endif
ifneq (,$(findstring sparc,$(UNICORN_ARCHS)))
SOURCES += sample_sparc.c
endif
ifneq (,$(findstring x86,$(UNICORN_ARCHS)))
SOURCES += sample_x86.c
SOURCES += shellcode.c
SOURCES += mem_apis.c
SOURCES += sample_x86_32_gdt_and_seg_regs.c
SOURCES += sample_batch_reg.c
endif
ifneq (,$(findstring m68k,$(UNICORN_ARCHS)))
SOURCES += sample_m68k.c
endif
ifneq (,$(findstring tricore,$(UNICORN_ARCHS)))
SOURCES += sample_tricore.c
endif

BINS = $(SOURCES:.c=$(BIN_EXT))
OBJS = $(SOURCES:.c=.o)

all: $(BINS)

$(BINS): $(OBJS)

clean:		
	rm -rf *.o $(BINS)

%$(BIN_EXT): %.o
	@mkdir -p $(@D)
ifeq ($(V),0)
ifeq ($(UNICORN_SHARED),yes)
	$(call log,LINK,$(notdir $@))
	@$(link-dynamic)
endif
ifeq ($(UNICORN_STATIC),yes)
ifneq ($(filter MINGW%,$(UNAME_S)),)
	$(call log,LINK,$(notdir $(call staticname,$@)))
	@$(link-static)
endif
endif
else
ifeq ($(UNICORN_SHARED),yes)
	$(link-dynamic)
endif
ifeq ($(UNICORN_STATIC),yes)
ifneq ($(filter MINGW%,$(UNAME_S)),)
	$(link-static)
endif
endif
endif

%.o: %.c
	@mkdir -p $(@D)
ifeq ($(V),0)
	$(call log,CC,$(@:%=%))
	@$(compile)
else
	$(compile)
endif


define link-dynamic
	$(CC) $< ${CFLAGS} $(LDFLAGS) -o $@
endef


define link-static
	$(CC) $< $(ARCHIVE) ${CFLAGS} $(LDFLAGS) -o $(call staticname,$@)
endef


staticname = $(subst $(BIN_EXT),,$(1)).static$(BIN_EXT)

define log
	@printf "  %-7s %s\n" "$(1)" "$(2)"
endef

define compile
	${CC} ${CFLAGS} -c $< -o $@
endef

=== bindings/java/Makefile ===
.PHONY: gen_const clean jar all lib samples install

all: gen_const
	$(MAKE) -f Makefile.build all

lib:
	$(MAKE) -f Makefile.build lib

samples:
	$(MAKE) -f  Makefile.build samples

jar:
	$(MAKE) -f Makefile.build jar

install: lib jar
	$(MAKE) -f Makefile.build install

uninstall:
	$(MAKE) -f Makefile.build uninstall

gen_const:
	cd .. && python3 const_generator.py java

clean:
	rm -f unicorn/*.class
	rm -f samples/*.class
	rm -f *.so
	rm -f *.dylib
	rm -f *.dll

=== bindings/python/Makefile ===
# Python binding for Unicorn engine. Nguyen Anh Quynh <aquynh@gmail.com>

.PHONY: gen_const install install3 clean sdist sdist3 bdist bdist3 sdist_win bdist_win

gen_const:
	cd .. && python3 const_generator.py python

install:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	if test -n "${DESTDIR}"; then \
		python3 setup.py install --root="${DESTDIR}"; \
	else \
		python3 setup.py install; \
	fi

install3:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	if test -n "${DESTDIR}"; then \
		python3 setup.py install --root="${DESTDIR}"; \
	else \
		python3 setup.py install; \
	fi

# build & upload PyPi package with source code of the core
sdist:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py sdist register upload

# build & upload PyPi package with source code of the core
sdist3:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py sdist register upload

# build & upload PyPi package with precompiled core
bdist:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py bdist_wheel register upload

# build & upload PyPi package with precompiled core
bdist3:
	rm -rf src/ dist/
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	python3 setup.py bdist_wheel register upload

# build & upload PyPi package with prebuilt core
# NOTE: be sure to have precompiled core under prebuilt/win*/ beforehand
sdist_win:
	rm -rf src/ dist/
	python3 setup.py sdist register upload

# build & upload PyPi package with prebuilt core
# NOTE: be sure to have precompiled core under prebuilt/win*/ beforehand
sdist3_win:
	rm -rf src/ dist/
	python3 setup.py sdist register upload

clean:
	rm -rf src/ dist/ build/ MANIFEST
	rm -rf prebuilt/win64/unicorn.dll
	rm -rf prebuilt/win32/unicorn.dll
	rm -rf unicorn/lib unicorn/include
	rm -rf unicorn/*.pyc
	rm -rf unicorn.egg-info


SAMPLES = sample_arm.py sample_arm64.py sample_mips.py
SAMPLES += sample_sparc.py sample_m68k.py sample_x86.py
check:
	@for t in $(SAMPLES); do \
		echo Check $$t ... ; \
		./$$t > /dev/null && echo OK || echo FAILED; \
	done

=== bindings/ruby/Makefile ===
# Ruby binding for Unicorn engine. Sascha Schirra <sashs@scoding.de>

.PHONY: gen_const

# Use bundle install && rake to install gem and test
install: gen_const
	cd unicorn_gem && rake build
	cd unicorn_gem && gem install --local pkg/unicorn-engine-2.0.0.gem

gen_const:
	cd .. && python3 const_generator.py ruby

=== tests/regress/Makefile ===
CFLAGS += -Wall -Werror -I../../include
CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
LDLIBS += -L../../ -lm -lunicorn

UNAME_S := $(shell uname -s)
LDLIBS += -pthread
ifeq ($(UNAME_S), Linux)
LDLIBS += -lrt
endif

EXECUTE_VARS = LD_LIBRARY_PATH=../../cmocka/src:../../ DYLD_LIBRARY_PATH=../../

TESTS_SOURCE = $(wildcard *.c)
TESTS = $(TESTS_SOURCE:%.c=%)

.PHONY: all clean test

test: $(TESTS)

all: $(TESTS)

clean:
	rm -f $(TESTS)

=== debian/changelog ===
unicorn-engine (2.0.1.post1-4build2) noble; urgency=medium

  * No-change upload to remove support of ruby3.1.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 20 Feb 2024 04:53:26 -0300

unicorn-engine (2.0.1.post1-4build1) noble; urgency=medium

  * No-change upload to add support for ruby3.2.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 02 Feb 2024 04:55:50 -0300

unicorn-engine (2.0.1.post1-4) unstable; urgency=medium

  * Fix build error with pybuild in dh_auto_clean

 -- Timo Röhling <roehling@debian.org>  Tue, 15 Aug 2023 18:04:35 +0200

unicorn-engine (2.0.1.post1-3) unstable; urgency=medium

  * Properly execute dh_auto_clean (Closes: #1048756)

 -- Timo Röhling <roehling@debian.org>  Tue, 15 Aug 2023 17:03:51 +0200

unicorn-engine (2.0.1.post1-2) unstable; urgency=medium

  * Make package cross-buildable
  * Bump Standards-Version to 4.6.2

 -- Timo Röhling <roehling@debian.org>  Mon, 19 Jun 2023 00:07:41 +0200

unicorn-engine (2.0.1.post1-1) unstable; urgency=medium

  * New upstream version 2.0.1.post1

 -- Timo Röhling <roehling@debian.org>  Fri, 25 Nov 2022 11:50:59 +0100

=== debian/control ===
Source: unicorn-engine
Section: libs
Priority: optional
Maintainer: Timo Röhling <roehling@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-sequence-ruby,
 gem2deb,
 pkgconf,
 rake,
 ruby-magic:native,
Build-Depends-Indep:
 dh-python,
 dh-sequence-python3,
 python3-all,
 python3-setuptools,
Homepage: https://unicorn-engine.org
Standards-Version: 4.6.2
XS-Ruby-Versions: all
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/roehling/unicorn-engine.git
Vcs-Browser: https://salsa.debian.org/roehling/unicorn-engine
Description: Lightweight CPU emulator framework
 Unicorn is a CPU emulator which is based on the CPU emulation code from
 QEMU. Unlike QEMU, it focuses on the emulation of CPU code without a
 full system emulation, but with the goal to make the emulation
 extensible and easy to integrate in custom tools. Unicorn provides
 language bindings for Python, Ruby, and Rust (among others) and has
 instrumentation hooks for various CPU events. This makes Unicorn well
 suited for malware analysis and reverse engineering.

Package: libunicorn2
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package installs the shared library of Unicorn.

Package: libunicorn-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libunicorn2 (= ${binary:Version}),
Description: ${source:Synopsis} (development headers)
 ${source:Extended-Description}
 .
 This package installs the headers and development files.

Package: python3-unicorn
Section: python
Architecture: all
Depends:
 ${misc:Depends},
 ${python3:Depends},
 libunicorn2 (>= ${source:Upstream-Version}),
Description: ${source:Synopsis} (Python 3 bindings)
 ${source:Extended-Description}
 .
 This package installs the Python 3 bindings.

Package: ruby-unicorn-engine
Section: ruby
Architecture: any
Multi-Arch: same
XB-Ruby-Versions: ${ruby:Versions}
X-DhRuby-Root: bindings/ruby/unicorn_gem
Depends:
 ${misc:Depends},
 ${ruby:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} (Ruby bindings)
 ${source:Extended-Description}
 .
 This package installs the Ruby bindings.

=== debian/watch ===
version=4
opts=filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,\
 uversionmangle=s/-(rc|a|b)/~$1/ \
 https://github.com/unicorn-engine/unicorn/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## unicorn-engine 2.1.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # CMake setup for Unicorn 2.
 # By Huitao Chen & Nguyen Anh Quynh, 2019-2020
 
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.5)
 
 # Only required for MSVC, but we can't know the compiler at this point because we haven't
 # called enable_language() or project(), and if we did that it would lock in the old
@@ -17,6 +17,14 @@
     cmake_policy(SET CMP0092 NEW)
 endif()
 
+# Honor visibility properties for all target types.
+cmake_policy(SET CMP0063 NEW)
+
+option(ZIG_BUILD "Enable zig build" OFF)
+if(ZIG_BUILD)
+    include(cmake/zig.cmake)
+endif()
+
 # Workaround to fix wrong compiler on macos.
 if(APPLE AND NOT CMAKE_C_COMPILER)
     set(CMAKE_C_COMPILER "/usr/bin/cc")
@@ -44,10 +52,10 @@
 set(CMAKE_C_STANDARD 11)
 
 set(UNICORN_VERSION_MAJOR 2)
-set(UNICORN_VERSION_MINOR 0)
+set(UNICORN_VERSION_MINOR 1)
 set(UNICORN_VERSION_PATCH 1)
 
-include(bundle_static.cmake)
+include(cmake/bundle_static.cmake)
 
 # Even though we generate shared lib and static archive at the same time, we still support
 # using unicorn as a subdirectory so we have to respect BUILD_SHARED_LIBS.
@@ -56,6 +64,7 @@
 # compatability.
 option(BUILD_SHARED_LIBS "Build shared instead of static library" ${PROJECT_IS_TOP_LEVEL})
 option(UNICORN_FUZZ "Enable fuzzing" OFF)
+option(UNICORN_LOGGING "Enable logging" OFF)
 option(UNICORN_BUILD_TESTS "Build unicorn tests" ${PROJECT_IS_TOP_LEVEL})
 option(UNICORN_INSTALL "Enable unicorn installation" ${PROJECT_IS_TOP_LEVEL})
 set(UNICORN_ARCH "x86;arm;aarch64;riscv;mips;sparc;m68k;ppc;s390x;tricore" CACHE STRING "Enabled unicorn architectures")
@@ -84,6 +93,14 @@
     qemu/tcg
 )
 
+# QEMU logging facility
+if (UNICORN_LOGGING)
+    add_compile_options(-DUNICORN_LOGGING)
+endif()
+
+# Some distributions on some rare architecures don't auto link atomic for us and
+# we do this manually by adding flags.
+set(ATOMIC_LINKAGE_FIX FALSE)
 if(MSVC)
     if(CMAKE_SIZEOF_VOID_P EQUAL 8)
         set(MSVC_FLAG  -D__x86_64__)
@@ -109,22 +126,25 @@
     add_compile_options($<$<COMPILE_LANGUAGE:C>:/wd4267>)
 
     # handle msvcrt setting being passed in CMAKE_C_FLAGS
-    if(DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
-        # do not support other methods of setting this (it would be more conformant, tho)
-        message(FATAL_ERROR "please set msvcrt via CMAKE_C_FLAGS")
-    endif()
-    if(CMAKE_C_FLAGS MATCHES "[/-]MTd")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebug")
-    elseif(CMAKE_C_FLAGS MATCHES "[/-]MDd")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebugDLL")
-    elseif(CMAKE_C_FLAGS MATCHES "[/-]MT")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
-    elseif(CMAKE_C_FLAGS MATCHES "[/-]MD")
-        set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
-    endif()
-
-    # prevent the arg from occurring more than once (not a big deal, just to keep tidy)
-    string(REGEX REPLACE "[/-]M[TD]d?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
+    if(CMAKE_C_FLAGS MATCHES "[/-]M[TD]d?")
+        # ensure CMAKE_MSVC_RUNTIME_LIBRARY is not already defined
+        if(DEFINED CMAKE_MSVC_RUNTIME_LIBRARY)
+            message(FATAL_ERROR "please set the runtime library via either CMAKE_C_FLAGS or CMAKE_MSVC_RUNTIME_LIBRARY, not both")
+        endif()
+
+        if(CMAKE_C_FLAGS MATCHES "[/-]MTd")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebug")
+        elseif(CMAKE_C_FLAGS MATCHES "[/-]MDd")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDebugDLL")
+        elseif(CMAKE_C_FLAGS MATCHES "[/-]MT")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
+        elseif(CMAKE_C_FLAGS MATCHES "[/-]MD")
+            set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreadedDLL")
+        endif()
+
+        # prevent the arg from occurring more than once (not a big deal, just to keep tidy)
+        string(REGEX REPLACE "[/-]M[TD]d?" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
+    endif()
 else()
     if(MINGW)
         execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpmachine
@@ -186,6 +206,7 @@
             string(FIND "${UC_COMPILER_MACRO}" "__arm__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "arm")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__aarch64__" UC_RET)
@@ -196,11 +217,13 @@
             string(FIND "${UC_COMPILER_MACRO}" "__mips__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "mips")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__sparc__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "sparc")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__ia64__" UC_RET)
@@ -211,16 +234,19 @@
             string(FIND "${UC_COMPILER_MACRO}" "_ARCH_PPC" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "ppc")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__riscv" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "riscv")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND "${UC_COMPILER_MACRO}" "__s390__" UC_RET)
             if(${UC_RET} GREATER_EQUAL "0")
                 set(UNICORN_TARGET_ARCH "s390")
+                set(ATOMIC_LINKAGE_FIX TRUE)
                 break()
             endif()
             string(FIND ${UC_COMPILER_MACRO} "__tricore__" UC_RET)
@@ -275,6 +301,13 @@
     if(UNICORN_TRACER)
         set (EXTRA_CFLAGS "${EXTRA_CFLAGS} -DUNICORN_TRACER")
     endif()
+    if (ATOMIC_LINKAGE_FIX)
+        set (EXTRA_CFLAGS "${EXTRA_CFLAGS} -latomic")
+    endif()
+    if (CMAKE_OSX_SYSROOT)
+        # https://github.com/unicorn-engine/unicorn/issues/1917
+        set (EXTRA_CFLAGS "${EXTRA_CFLAGS} -isysroot ${CMAKE_OSX_SYSROOT} ")
+    endif()
 
     set(TARGET_LIST "--target-list=")
     if(UNICORN_HAS_X86)
@@ -284,35 +317,3 @@
         set(TARGET_LIST "${TARGET_LIST}arm-softmmu, ")
     endif()
     if(UNICORN_HAS_AARCH64)
-        set(TARGET_LIST "${TARGET_LIST}aarch64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_M68K)
-        set(TARGET_LIST "${TARGET_LIST}m68k-softmmu, ")
-    endif()
-    if(UNICORN_HAS_MIPS)
-        set(TARGET_LIST "${TARGET_LIST}mips-softmmu, mipsel-softmmu, mips64-softmmu, mips64el-softmmu, ")
-    endif()
-    if(UNICORN_HAS_SPARC)
-        set(TARGET_LIST "${TARGET_LIST}sparc-softmmu, sparc64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_PPC)
-        set(TARGET_LIST "${TARGET_LIST}ppc-softmmu, ppc64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_RISCV)
-        set(TARGET_LIST "${TARGET_LIST}riscv32-softmmu, riscv64-softmmu, ")
-    endif()
-    if(UNICORN_HAS_S390X)
-        set(TARGET_LIST "${TARGET_LIST}s390x-softmmu, ")
-    endif()
-    if (UNICORN_HAS_TRICORE)
-        set (TARGET_LIST "${TARGET_LIST}tricore-softmmu, ")
-    endif()
-    set(TARGET_LIST "${TARGET_LIST} ")
-
-    # GEN config-host.mak & target directories
-    execute_process(COMMAND sh ${CMAKE_CURRENT_SOURCE_DIR}/qemu/configure
-        --cc=${CMAKE_C_COMPILER}
-        ${EXTRA_CFLAGS}
-        ${TARGET_LIST}
-        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
-    )

=== bindings/ruby/Makefile ===
# Ruby binding for Unicorn engine. Sascha Schirra <sashs@scoding.de>

.PHONY: gen_const

# Use bundle install && rake to install gem and test
install: gen_const
	cd unicorn_gem && rake build
	cd unicorn_gem && gem install --local pkg/unicorn-engine-2.1.1.gem

gen_const:
	cd .. && python3 const_generator.py ruby

=== debian/changelog ===
unicorn-engine (2.1.1-2) unstable; urgency=medium

  * Fix FTBFS with s390x (big endian issue) (Closes: #1088921)

 -- Timo Röhling <roehling@debian.org>  Thu, 05 Dec 2024 11:57:13 +0100

unicorn-engine (2.1.1-1) unstable; urgency=medium

  * New upstream version 2.1.1
  * Refresh patches (no functional changes)
  * Wrap and sort Debian package files
  * Bump Standards-Version to 4.7.0

 -- Timo Röhling <roehling@debian.org>  Mon, 02 Dec 2024 09:07:12 +0100

unicorn-engine (2.0.1.post1-5) unstable; urgency=medium

  * Fix FTBFS in ruby gem (Closes: #1075608)

 -- Timo Röhling <roehling@debian.org>  Fri, 16 Aug 2024 22:23:20 +0200

unicorn-engine (2.0.1.post1-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063012

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 21:11:59 +0000

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,10 @@
 Priority: optional
 Maintainer: Timo Röhling <roehling@debian.org>
 Build-Depends:
+ cmake,
  debhelper-compat (= 13),
- cmake,
  dh-sequence-ruby,
+ dpkg-dev (>= 1.22.5),
  gem2deb,
  pkgconf,
  rake,
@@ -16,7 +17,7 @@
  python3-all,
  python3-setuptools,
 Homepage: https://unicorn-engine.org
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 XS-Ruby-Versions: all
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/roehling/unicorn-engine.git
@@ -30,7 +31,13 @@
  instrumentation hooks for various CPU events. This makes Unicorn well
  suited for malware analysis and reverse engineering.
 
-Package: libunicorn2
+Package: libunicorn2t64
+Provides:
+ ${t64:Provides},
+Replaces:
+ libunicorn2,
+Breaks:
+ libunicorn2 (<< ${source:Version}),
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -46,8 +53,8 @@
 Architecture: any
 Multi-Arch: same
 Depends:
+ libunicorn2t64 (= ${binary:Version}),
  ${misc:Depends},
- libunicorn2 (= ${binary:Version}),
 Description: ${source:Synopsis} (development headers)
  ${source:Extended-Description}
  .
@@ -57,9 +64,9 @@
 Section: python
 Architecture: all
 Depends:
+ libunicorn2t64 (>= ${source:Upstream-Version}),
  ${misc:Depends},
  ${python3:Depends},
- libunicorn2 (>= ${source:Upstream-Version}),
 Description: ${source:Synopsis} (Python 3 bindings)
  ${source:Extended-Description}
  .

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export PYBUILD_NAME = unicorn
export DH_RUBY = --gem-install

%:
	dh $@ --buildsystem=cmake

ifeq ($(DEB_HOST_ARCH_ENDIAN),big)
override_dh_auto_test:
	-dh_auto_test -O--buildsystem=cmake
endif

execute_after_dh_auto_clean-arch \
execute_after_dh_auto_configure-arch \
execute_after_dh_auto_build-arch \
execute_after_dh_auto_install-arch: execute_after_%-arch:
	CPATH=$(CURDIR)/include \
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) \
	$* --buildsystem=ruby

execute_after_dh_auto_configure-indep \
execute_after_dh_auto_build-indep \
execute_after_dh_auto_install-indep: execute_after_%-indep:
	LD_LIBRARY_PATH=$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE) \
	$* --buildsystem=pybuild --sourcedirectory=bindings/python
